#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPL(t, x) bool operator<(CRP(t, x)) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
typedef long long ll, i64;
const int N = 1e6 + 50;
bool vis[N];
int a[N];
void read(int &x)
{
    int ch = x = 0;
    while (!isdigit(ch)) ch = getchar();
    for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
}
int main()
{
    int n, m, q;
    read(n), read(m), read(q);
    for (int i = 1; i <= n; i++) read(a[i]);
    for (int i = 1, x, y; i < m; i++)
    {
        read(x), read(y);
        if (x == y) continue;
        vis[x] = true;
    }
    for (int i = 1; i <= n; i++)
    {
        if (vis[i]) a[i] = 0;
        a[i] += a[i - 1];
    }
    ll ans = 0;
    for (int i = 1, x, y; i <= q; i++)
    {
        read(x), read(y);
        ans ^= i * (a[y] - a[x - 1]);
    }
    printf("%lld", ans);
    return 0;
}